/* [ʞ] safekill.c <c.hale.su/lexi/util>
 *  ~ lexi hale <lexi@hale.su>
 *  $ cc -Ofast safekill.c -lX11 -osafekill
 *  © affero general public license
 
 * a utility to make it harder to accidentally nuke
 * important windows on i3wm or whatever.

 TODO add option to run as daemon that listens for
      key chords, for wms that don't have built-in
      support for user keybindings */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
typedef enum { false, true } bool;

Display *display;
Atom xvital;

bool isvital(Window w) {
	unsigned char* value;
	int _i; long _l;
	Atom type;
	XGetWindowProperty(display,w, xvital, 0,1,False,xvital,
				&type,&_i,&_l,&_l, &value);
	return type != None;
}

void killwin(Window w) {
	XEvent ev;
	long mask = SubstructureRedirectMask | SubstructureNotifyMask;
	ev.xclient.type       = ClientMessage;
	ev.xclient.serial     = 0;
	ev.xclient.send_event = True;
	ev.xclient.message_type = XInternAtom(display, "_NET_CLOSE_WINDOW", False);
	ev.xclient.window     = w;
	ev.xclient.format     = 32;
	
	if(!XSendEvent(display, DefaultRootWindow(display), False, mask, &ev)) {
		char* fallback = getenv("k_safekill_fallback");
		bool nofb = (*fallback == '0' && fallback[1] == 0);

		fprintf(stderr,"\x1b[1mwarning:\x1b[m cannot send _NET_CLOSE_WINDOW event to root window; is your window manager okay?");

		if (nofb) {
			fprintf(stderr,"\n");
		} else {
			fprintf(stderr," falling back to XDestroyWindow, but this may wreck your shit - lots of multi-win apps do *not* like it.\n");
			XDestroyWindow(display,w);
		}
	}
}

bool isnum(const char* str) {
	// is the string passed something strtoul can interpret as a
	// number? decimal, hex, or octal?
	if (*str == '0' && str[1] == 0) return true;

	enum { hex, dec, oct } mode;
	if (*str == '0' && str[1] == 'x') mode = hex, str += 2;
	            else if (*str == '0') mode = oct, str += 1;
			                     else mode = dec;
	bool first = true;
	eval: if(*str == 0) return !first;
		  first = false;
		  if(*str >= '0' && *str <= '7') {
			  ++ str; goto eval;
		  } else if ((mode == dec || mode == hex) && *str >= '0' && *str <= '9') {
			  ++ str; goto eval;
		  } else if (mode == hex && (
				  (*str >= 'a' && *str <= 'f') ||
				  (*str >= 'A' && *str <= 'F'))) {
			  ++ str; goto eval;
		  } else return false;
}

int bad(Display* d, XErrorEvent* e) {
	printf("\x1b[1merror:\x1b[m no such window\n");
	exit(1);
}

int main(const int argc, const char** argv) {
	Window focus;
	int revert;

	bool active;
	enum { vitalize, devitalize, hardkill, softkill } op;

	const char* winp = argv[2];
	if (argc >  3) goto usage; // nope
	if (argc == 1) // no parameters, implied softkill on active win
		op = softkill, active = true;
	else {
		if (argc == 2) { // single argument; what kind is it?
			if (isnum(argv[1])) { // single numeric argument = win id 
				active = false; // window is specified for us
				op     = softkill; // implied softkill
				winp   = argv[1]; // interpret argv[1] as window id
				goto   go_go_go; // skip the rest of this nonsense;
					// we already know there's no switch
			} else {
				active = true; // no number passed, so it's either a
				// switch with an implied active window or bad syntax
				// now we need to figure out which
			}
		} else if (argc == 3) active = false; // win id AND opt

		// determine mission parameters
		if (argv[1][0] == '-' && argv[1][2] == 0) { // opt is short switch
			switch (argv[1][1]) { // opt char
				// make window mission-critical
				case 'v': op = vitalize; break;

				// make window acceptable loss
				case 'c': op = devitalize; break;

				// liquidate by any means necessary
				case 'q': op = hardkill; break;

				// with all due respect sir what the fuck
				default: goto usage;
			}
		} else goto usage;
	}

go_go_go:
	display = XOpenDisplay(NULL);
	xvital = XInternAtom(display, "_k_vital", False);
	XSetErrorHandler(bad);

	if (active) {
		XGetInputFocus(display, &focus, &revert);
	} else {
		unsigned long temp = strtoul(winp, NULL, 0);
		if (errno == EINVAL || errno == ERANGE) goto usage;
		if (temp == 0) goto usage;
		focus = (Window)temp;
	}

	if(op == hardkill) {
		killwin(focus);
		XSync(display,false);
		return 0;
	}

	char* v;
	if(isvital(focus)) {
		if        (op == vitalize) return 0; // nothing need be done
		else if   (op == devitalize) {
			XDeleteProperty(display, focus, xvital);
			XSync(display,false);
		} else if (op == softkill) {
			fprintf(stderr, "softkill forbidden\n");
			return 1; // ACCESS DENIED
		}
	} else {
		if        (op == vitalize) {
			char* yes="\01"; //arbitrary
			XChangeProperty(display,focus, xvital,xvital,8,PropModeReplace, yes, 1);
			XSync(display,false);
		} else if (op == devitalize) return 0;
		else if   (op == softkill) {
			// ice that motherfucker
			killwin(focus);
			XSync(display,false);
			return 3;
		}
	}

	return 0;

usage:
	#define info  "\x1b[34m-- "
	#define param "\x1b[32m"
	#define eol   "\x1b[m\n"
	#define bold  "\x1b[1m"
	#define nl    "       "
	fprintf(stderr, bold "usage:\x1b[0m %1$s    "       "     " info "kill active window if non-vital" eol
						 nl "%1$s -v " param "[id] " info "make [id] or active window vital" eol
						 nl "%1$s -c " param "[id] " info "clear vital flag on [id] or active window" eol
						 nl "%1$s -q " param "[id] " info "'emergency' kill w/o reference to vital flag" eol,
				argv[0]);
	return 1;
}
